//Example Fryers interface unit for Borland C
//This example will compile under any version of Borland BCB
//Copyright 2000 Frye Electronics, Inc.
//Written by Michael Day as of 5 July 2000 
//Used by F32test.CPP
//Note: if you are using Delphi 2.0 or above, or Borland BCB
//see FSAMPLES for FryersP.PAS or FryersC.CPP which are more
//extensive Fryers interfaces for Win32 applications.

#include <windows.h>
#pragma anon_struct on
#include "FryeRegs.h"
#include "FryersCE.h"

HINSTANCE FryersLibHandle = NULL;
tCallFryers CallFryers = NULL;

bool __stdcall FryersLoaded(void)
{
  FryersLibHandle = LoadLibrary("fryers32.dll");
  if (FryersLibHandle != NULL) {
    CallFryers = (tCallFryers)GetProcAddress(FryersLibHandle, "CallFryers");
    if (CallFryers != NULL)
      return(TRUE);
  } return(FALSE);
}

//----------------------------------------------
//For example only. Normally you should not call this.
//Windows till release the DLL properly when the program shuts down.
bool ReleaseFryers(void){
  bool fFreeResult = FreeLibrary(FryersLibHandle);
  return(fFreeResult);
}


//-------------------------------------------------
// Example call to return Fryers version number
int GetFryersVersion(void) {
 F_RegsType R;
  if (FryersLibHandle == NULL)
    if (!FryersLoaded()) return(-1);
  R.AX = 0xFFFF;
  R.DX = 0;
  R.CX = 0;
  CallFryers(&R);
  if ((R.DX & 0xFFFF) != 0xFFFF)
    R.AL = 0;
  return(R.AL);
}
