//---------------------------------------------------------------------------
//Bit Reverse map
//Copyright 2010 Frye Electronics, Inc.
//Written by Michael Day as of 30 Aug 2010
//You may use this code for any lawful purpose without fees or royalties.
//This code is intended as an example showing how to communicate with Fonix
//equipment using the Fryers32 or FryeCom device driver on the Windows operating system.
//No warranties are express or implied in the use of this code.
//---------------------------------------------------------------------------

//unit BitRev;
#include "BitRev.h"

/*
//common bit defines
const BIT0 = 0x0001;
const BIT1 = 0x0002;
const BIT2 = 0x0004;
const BIT3 = 0x0008;
const BIT4 = 0x0010;
const BIT5 = 0x0020;
const BIT6 = 0x0040;
const BIT7 = 0x0080;
const BIT8 = 40100;
const BIT9 = 0x0200;
const BIT10 = 0x0400;
const BIT11 = 0x0800;
const BIT12 = 0x1000;
const BIT13 = 0x2000;
const BIT14 = 0x4000;
const BIT15 = 0x8000;
*/

const char BitReverse[256] = {
   0x00,0x80,0x40,0xC0,  //;00H - 03H
   0x20,0xA0,0x60,0xE0,  //;04H - 07H
   0x10,0x90,0x50,0xD0,  //;08H - 0BH
   0x30,0xB0,0x70,0xF0,  //;0CH - 0FH
   0x08,0x88,0x48,0xC8,  //;10H - 13H
   0x28,0xA8,0x68,0xE8,  //;14H - 17H
   0x18,0x98,0x58,0xD8,  //;18H - 1BH
   0x38,0xB8,0x78,0xF8,  //;1CH - 1FH
   0x04,0x84,0x44,0xC4,  //;20H - 23H
   0x24,0xA4,0x64,0xE4,  //;24H - 27H
   0x14,0x94,0x54,0xD4,  //;28H - 2BH
   0x34,0xB4,0x74,0xF4,  //;2CH - 2FH
   0x0C,0x8C,0x4C,0xCC,  //;30H - 33H
   0x2C,0xAC,0x6C,0xEC,  //;34H - 37H
   0x1C,0x9C,0x5C,0xDC,  //;38H - 3BH
   0x3C,0xBC,0x7C,0xFC,  //;3CH - 3FH
   0x02,0x82,0x42,0xC2,  //;40H - 43H
   0x22,0xA2,0x62,0xE2,  //;44H - 47H
   0x12,0x92,0x52,0xD2,  //;48H - 4BH
   0x32,0xB2,0x72,0xF2,  //;4CH - 4FH
   0x0A,0x8A,0x4A,0xCA,  //;50H - 53H
   0x2A,0xAA,0x6A,0xEA,  //;54H - 57H
   0x1A,0x9A,0x5A,0xDA,  //;58H - 5BH
   0x3A,0xBA,0x7A,0xFA,  //;5CH - 5FH
   0x06,0x86,0x46,0xC6,  //;60H - 63H
   0x26,0xA6,0x66,0xE6,  //;64H - 67H
   0x16,0x96,0x56,0xD6,  //;68H - 6BH
   0x36,0xB6,0x76,0xF6,  //;6CH - 6FH
   0x0E,0x8E,0x4E,0xCE,  //;70H - 73H
   0x2E,0xAE,0x6E,0xEE,  //;74H - 77H
   0x1E,0x9E,0x5E,0xDE,  //;78H - 7BH
   0x3E,0xBE,0x7E,0xFE,  //;7CH - 7FH
   0x01,0x81,0x41,0xC1,  //;80H - 83H
   0x21,0xA1,0x61,0xE1,  //;84H - 87H
   0x11,0x91,0x51,0xD1,  //;88H - 8BH
   0x31,0xB1,0x71,0xF1,  //;8CH - 8FH
   0x09,0x89,0x49,0xC9,  //;90H - 93H
   0x29,0xA9,0x69,0xE9,  //;94H - 97H
   0x19,0x99,0x59,0xD9,  //;98H - 9BH
   0x39,0xB9,0x79,0xF9,  //;9CH - 9FH
   0x05,0x85,0x45,0xC5,  //;A0H - A3H
   0x25,0xA5,0x65,0xE5,  //;A4H - A7H
   0x15,0x95,0x55,0xD5,  //;A8H - ABH
   0x35,0xB5,0x75,0xF5,  //;ACH - AFH
   0x0D,0x8D,0x4D,0xCD,  //;B0H - B3H
   0x2D,0xAD,0x6D,0xED,  //;B4H - B7H
   0x1D,0x9D,0x5D,0xDD,  //;B8H - BBH
   0x3D,0xBD,0x7D,0xFD,  //;BCH - BFH
   0x03,0x83,0x43,0xC3,  //;COH - C3H
   0x23,0xA3,0x63,0xE3,  //;C4H - C7H
   0x13,0x93,0x53,0xD3,  //;C8H - CBH
   0x33,0xB3,0x73,0xF3,  //;CCH - CFH
   0x0B,0x8B,0x4B,0xCB,  //;D0H - D3H
   0x2B,0xAB,0x6B,0xEB,  //;D4H - D7H
   0x1B,0x9B,0x5B,0xDB,  //;D8H - DBH
   0x3B,0xBB,0x7B,0xFB,  //;DCH - DFH
   0x07,0x87,0x47,0xC7,  //;E0H - E3H
   0x27,0xA7,0x67,0xE7,  //;E4H - E7H
   0x17,0x97,0x57,0xD7,  //;E8H - EBH
   0x37,0xB7,0x77,0xF7,  //;ECH - EFH
   0x0F,0x8F,0x4F,0xCF,  //;F0H - F3H
   0x2F,0xAF,0x6F,0xEF,  //;F4H - F7H
   0x1F,0x9F,0x5F,0xDF,  //;F8H - FBH
   0x3F,0xBF,0x7F,0xFF   //;FCH - FFH
};

//<eof>

