//Fryers32 Interface header file for Fryers32.CPP
//Copyright 2001 Frye Electronics, Inc.
//Written by Michael Day as of 10 Oct 2010
//--------------------------------------------------------------------
//Note: this is provided to allow update of older Fryers32 programs.
//You should consider migrating your new programs to use the FippCore interface.
//---------------------------------------------------------------------


//--------------File Fryers32.h--------------------------------
#ifndef Fryers32H
#define Fryers32H

#include "FryeRegs.h" //This defines the IRegs structure.
#include "Fryers.h"   //This provides the DLL definitions.



//--------------------------------
//These items are not normally used, they are available for debugging.
typedef int tHandle;
typedef void __stdcall (*tCallFryers)(F_RegsType* IRegs);

extern HINSTANCE FryersLibHandle;
extern tCallFryers CallFryersProc;
extern bool FryersActive;
extern tHandle FRYERS32_PortHandle;
extern char FRYERS32_DllFilename[256];    //name of the DLL file being used

//------------------------------------------------
//calling interface to the Fryers Driver
extern int __stdcall CallFryers(F_RegsType* IRegs);

extern int FRYERS32_LastComPort(void);
extern int FRYERS32_GetShortFryersVersion(int* ShortVersion);
extern int FRYERS32_GetVersionString(AnsiString* Vers);
extern int FRYERS32_GetLongFryersVersion(int* LongVersion);

//--------------------------------
#endif

